# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_runbookdirectory`](#dsc_runbookdirectory): The DSC RunbookDirectory resource type. Automatically generated from version 2.1.0.0
* [`dsc_smavariable`](#dsc_smavariable): The DSC SmaVariable resource type. Automatically generated from version 2.1.0.0
* [`dsc_xscsmapowershellsetup`](#dsc_xscsmapowershellsetup): The DSC xSCSMAPowerShellSetup resource type. Automatically generated from version 2.1.0.0
* [`dsc_xscsmarunbookworkerserversetup`](#dsc_xscsmarunbookworkerserversetup): The DSC xSCSMARunbookWorkerServerSetup resource type. Automatically generated from version 2.1.0.0
* [`dsc_xscsmawebserviceserversetup`](#dsc_xscsmawebserviceserversetup): The DSC xSCSMAWebServiceServerSetup resource type. Automatically generated from version 2.1.0.0
* [`dsc_xsmacredential`](#dsc_xsmacredential): The DSC xSmaCredential resource type. Automatically generated from version 2.1.0.0

## Resource types

### <a name="dsc_runbookdirectory"></a>`dsc_runbookdirectory`

The DSC RunbookDirectory resource type.
Automatically generated from version 2.1.0.0

#### Properties

The following properties are available in the `dsc_runbookdirectory` type.

##### `dsc_ensure`

Data type: `Enum['Published', 'Draft', 'Absent']`

The import state of runbooks found at RunbookPath. This can be Published, Draft, or Absent

##### `dsc_matches`

Data type: `Optional[Boolean]`

Describes the validity of the imported Runbook(s).

##### `dsc_port`

Data type: `Optional[Integer[0, 4294967295]]`

Port of the SMA web site. Defaults to the SMA default of 9090.

#### Parameters

The following parameters are available in the `dsc_runbookdirectory` type.

* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_runbookpath`](#dsc_runbookpath)
* [`dsc_webserviceendpoint`](#dsc_webserviceendpoint)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_runbookpath"></a>`dsc_runbookpath`

namevar

Data type: `String`

Path to Runbook(s) to be imported. Accepts wildcards.

##### <a name="dsc_webserviceendpoint"></a>`dsc_webserviceendpoint`

namevar

Data type: `String`

URL of SMA's web service endpoint.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_smavariable"></a>`dsc_smavariable`

The DSC SmaVariable resource type.
Automatically generated from version 2.1.0.0

#### Properties

The following properties are available in the `dsc_smavariable` type.

##### `dsc_description`

Data type: `Optional[String]`

Description of SMA variable.

##### `dsc_ensure`

Data type: `Enum['Present', 'Absent']`

Desired state of SMA variable

##### `dsc_port`

Data type: `Optional[Integer[0, 4294967295]]`

Port to reach the web service endpoint. Defaults to the SMA default of 9090.

##### `dsc_set`

Data type: `Optional[Boolean]`

Set is true if existing SMA variable matches configuration.

##### `dsc_value`

Data type: `String`

Value of SMA variable.

#### Parameters

The following parameters are available in the `dsc_smavariable` type.

* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_webserviceendpoint`](#dsc_webserviceendpoint)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Name of SMA variable.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_webserviceendpoint"></a>`dsc_webserviceendpoint`

namevar

Data type: `String`

Web service endpoint of SMA instance.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xscsmapowershellsetup"></a>`dsc_xscsmapowershellsetup`

The DSC xSCSMAPowerShellSetup resource type.
Automatically generated from version 2.1.0.0

#### Properties

The following properties are available in the `dsc_xscsmapowershellsetup` type.

##### `dsc_sourcefolder`

Data type: `Optional[String]`

Folder within the source path containing the source files for installation.

##### `dsc_sourcepath`

Data type: `String`

UNC path to the root of the source files for installation.

#### Parameters

The following parameters are available in the `dsc_xscsmapowershellsetup` type.

* [`dsc_ensure`](#dsc_ensure)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_setupcredential`](#dsc_setupcredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_ensure"></a>`dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

An enumerated value that describes if SMA PowerShell is expected to be installed on the machine. Present {default}  
Absent

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_setupcredential"></a>`dsc_setupcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xscsmarunbookworkerserversetup"></a>`dsc_xscsmarunbookworkerserversetup`

The DSC xSCSMARunbookWorkerServerSetup resource type.
Automatically generated from version 2.1.0.0

#### Properties

The following properties are available in the `dsc_xscsmarunbookworkerserversetup` type.

##### `dsc_etwmanifest`

Data type: `Optional[String]`

Log to ETW.

##### `dsc_installfolder`

Data type: `Optional[String]`

Installation folder for SMA.

##### `dsc_logmsiinstall`

Data type: `Optional[String]`

Set to activate logging during install of MSI.

##### `dsc_msilogname`

Data type: `Optional[String]`

Logfile name for MSI install.

##### `dsc_msilogpath`

Data type: `Optional[String]`

Path to log file for MSI install.

##### `dsc_msupdate`

Data type: `Optional[String]`

Use Microsoft Update.

##### `dsc_productkey`

Data type: `Optional[String]`

Product key for licensed installations.

##### `dsc_sendtelemetryreports`

Data type: `Optional[String]`

Usage and Diagnostics Data sent to Microsoft.

##### `dsc_serviceusername`

Data type: `Optional[String]`

Output username of the Service account of the web service application pool.

##### `dsc_sourcefolder`

Data type: `Optional[String]`

Folder within the source path containing the source files for installation.

##### `dsc_sourcepath`

Data type: `String`

UNC path to the root of the source files for installation.

##### `dsc_sqldatabase`

Data type: `Optional[String]`

Name of the SMA database.

##### `dsc_sqlinstance`

Data type: `String`

Name of the SQL Instance for the SMA database.

##### `dsc_sqlserver`

Data type: `String`

Name of the SQL Server for the SMA database.

#### Parameters

The following parameters are available in the `dsc_xscsmarunbookworkerserversetup` type.

* [`dsc_ensure`](#dsc_ensure)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_service`](#dsc_service)
* [`dsc_setupcredential`](#dsc_setupcredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_ensure"></a>`dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

An enumerated value that describes if the SMA Runbook Worker server is expected to be installed on the machine. Present
{default}   Absent

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_service"></a>`dsc_service`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Service account of the web service application pool.

##### <a name="dsc_setupcredential"></a>`dsc_setupcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xscsmawebserviceserversetup"></a>`dsc_xscsmawebserviceserversetup`

The DSC xSCSMAWebServiceServerSetup resource type.
Automatically generated from version 2.1.0.0

#### Properties

The following properties are available in the `dsc_xscsmawebserviceserversetup` type.

##### `dsc_admingroupmembers`

Data type: `Optional[String]`

A comma-separated list of users to add to the IIS Administrators group.

##### `dsc_appoolusername`

Data type: `Optional[String]`

Output username of the web service application pool.

##### `dsc_certificatename`

Data type: `Optional[String]`

Name of the existing certificate to use.

##### `dsc_etwmanifest`

Data type: `Optional[String]`

Log to ETW.

##### `dsc_firstwebserviceserver`

Data type: `Boolean`

Is this the first Management Server?

##### `dsc_installfolder`

Data type: `Optional[String]`

Installation folder for SMA.

##### `dsc_logmsiinstall`

Data type: `Optional[String]`

Set to activate logging during install of MSI.

##### `dsc_msilogname`

Data type: `Optional[String]`

Logfile name for MSI install.

##### `dsc_msilogpath`

Data type: `Optional[String]`

Path to log file for MSI install

##### `dsc_msupdate`

Data type: `Optional[String]`

Use Microsoft Update.

##### `dsc_productkey`

Data type: `Optional[String]`

Product key for licensed installations.

##### `dsc_runbookworkerservers`

Data type: `Optional[Array[String]]`

Array of Runbook Worker servers in this deployment.

##### `dsc_sendtelemetryreports`

Data type: `Optional[String]`

Usage and Diagnostics Data sent to Microsoft.

##### `dsc_sitename`

Data type: `Optional[String]`

Name of the SMA web site.

##### `dsc_sourcefolder`

Data type: `Optional[String]`

Folder within the source path containing the source files for installation.

##### `dsc_sourcepath`

Data type: `String`

UNC path to the root of the source files for installation.

##### `dsc_specifycertificate`

Data type: `Optional[String]`

Specify an existing certificate for the SMA web site.

##### `dsc_sqldatabase`

Data type: `Optional[String]`

Name of the SMA database.

##### `dsc_sqlinstance`

Data type: `String`

Name of the SQL Instance for the SMA database.

##### `dsc_sqlserver`

Data type: `String`

Name of the SQL Server for the SMA database.

##### `dsc_usessl`

Data type: `Optional[String]`

Use SSL?

##### `dsc_webserviceport`

Data type: `Optional[Integer[0, 65535]]`

Port of the SMA web site.

#### Parameters

The following parameters are available in the `dsc_xscsmawebserviceserversetup` type.

* [`dsc_appool`](#dsc_appool)
* [`dsc_ensure`](#dsc_ensure)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_setupcredential`](#dsc_setupcredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_appool"></a>`dsc_appool`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Service account of the web service application pool.

##### <a name="dsc_ensure"></a>`dsc_ensure`

namevar

Data type: `Enum['Present', 'Absent']`

An enumerated value that describes if the SMA Web Service server is expected to be installed on the machine. Present
{default}   Absent

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_setupcredential"></a>`dsc_setupcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to be used to perform the installation.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xsmacredential"></a>`dsc_xsmacredential`

The DSC xSmaCredential resource type.
Automatically generated from version 2.1.0.0

#### Properties

The following properties are available in the `dsc_xsmacredential` type.

##### `dsc_description`

Data type: `Optional[String]`

Description of credential.

##### `dsc_port`

Data type: `Optional[Integer[0, 4294967295]]`

Port to reach the web service endpoint.

##### `dsc_username`

Data type: `Optional[String]`

User name of credential found within SMA

##### `dsc_webserviceendpoint`

Data type: `String`

Web service endpoint of SMA instance.

#### Parameters

The following parameters are available in the `dsc_xsmacredential` type.

* [`dsc_credential`](#dsc_credential)
* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential object to be imported.

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Name of credential.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

